unit UPong;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TWin = class(TForm)
    Ball: TShape;
    Paddle: TShape;
    Timer1: TTimer;
    Button1: TButton;
    Label1: TLabel;
    KIPaddle: TShape;
    Help: TShape;
    Label2: TLabel;
    procedure Release(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Press(Sender: TObject; var Key: Char);
    procedure Play(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Step(Sender: TObject);
    procedure Kollision(Ball: TShape; vx: Integer; vy: Integer; player: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    var ballvx: Integer;
    var ballvy: Integer;
    var paddlevx: Integer;
    var kipaddlevx: Integer;
    var helpvx: Integer;
    var helpvy: Integer;
  end;

var
  Win: TWin;

implementation

{$R *.dfm}

procedure TWin.FormCreate(Sender: TObject);
begin
  ballvy := 10;
  ballvx := 10;
end;

procedure TWin.Play(Sender: TObject);
begin
  Button1.Visible := False;
  Label1.Visible := False;
  Ball.Left := 288;
  Ball.Top := 304;
  ballvy := -10;
  ballvx := 10;
end;

procedure TWin.Press(Sender: TObject; var Key: Char);
begin
  if (Key = 'a') and not (Paddle.Left <= 0) then paddlevx := -5;
  if (Key = 'd') and not ((Paddle.Left + 170) >= 690) then paddlevx := 5;
end;

procedure TWin.Release(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  paddlevx := 0;
end;

procedure TWin.Step(Sender: TObject);
begin
  Ball.Top := Ball.Top + ballvy;
  Ball.Left := Ball.Left + ballvx;

  Paddle.Left := Paddle.Left + paddlevx;

  if (Paddle.Left <= 0) then paddlevx := 0;
  if ((Paddle.Left + 170) >= 690) then paddlevx := 0;

  Kollision(Ball,ballvx,ballvy,True);

  Help.Left := Help.Left + helpvx;

  Kollision(Help,helpvx,helpvy,False);

  if (Help.Left + 20) > (KIPaddle.Left + 85) then kipaddlevx := 10;
  if (Help.Left + 20) < (KIPaddle.Left + 85) then kipaddlevx := -10;
  if (Help.Left + 20) = (KIPaddle.Left + 85) then kipaddlevx := 0;

  KIPaddle.Left := KIPaddle.Left + kipaddlevx;
end;

procedure TWin.Kollision(Ball: TShape; vx: Integer; vy: Integer;player: Boolean);
begin
  if (Ball.Left <= 0) then vx := -vx;
  if ((Ball.Left + 40) >= 690) then vx := -vx;
  if ((Ball.Top + 40) >= Paddle.Top) then
  begin
    if ((Ball.Left + 20) > Paddle.Left) and
       ((Ball.Left + 20) < (Paddle.Left + Paddle.Width)) then
       begin
        vy := -vy;
        if player then
        begin
          Help.Top := Ball.Top;
          Help.Left := Ball.Left;
          helpvx := 15;
          helpvy := 15;
          if (ballvx < 0) then helpvx := -15;
          if (ballvy < 0) then helpvy := -15;
        end;
    end
    else
    begin
      if player then
      begin
        vx := 0;
        vy := 0;
        Label1.Visible := True;
        Button1.Visible := True;
      end;
    end;
  end;
  if (Ball.Top <= KIPaddle.Top + KIPaddle.Height) then
    begin
      if ((Ball.Left + 20) > KIPaddle.Left) and
         ((Ball.Left + 20) < (KIPaddle.Left + KIPaddle.Width)) then
      begin
        if player then
        begin
          vy := -vy;
        end
        else
        begin
          helpvx := 0;
          helpvy := 0;
        end;
      end
      else
      begin
        vx := 0;
        vy := 0;
        Win.Visible := True;
        Button1.Visible := True;
      end;
    end;
  if player then
  begin
    ballvx := vx;
    ballvy := vy;
  end
  else
  begin
    helpvx := vx;
    helpvy := vy;
  end;
end;

end.
